commit 4d929cd27e66c7d9c519cbcd77f12e1d58e85689
Author: H.J. Lu <hjl.tools@gmail.com>
Date:   Tue Jul 1 11:17:06 2025

    x86-64: Add RDI clobber to tls_global_dynamic_64 patterns
    
    *tls_global_dynamic_64_<mode> uses RDI as the __tls_get_addr argument.
    Add RDI clobber to tls_global_dynamic_64 patterns to show it.
    
            PR target/120908
            * config/i386/i386.cc (legitimize_tls_address): Pass RDI to
            gen_tls_global_dynamic_64.
            * config/i386/i386.md (*tls_global_dynamic_64_<mode>): Add RDI
            clobber and use it to generate LEA.
            (@tls_global_dynamic_64_<mode>): Add a clobber.
    
    Signed-off-by: H.J. Lu <hjl.tools@gmail.com>
    (cherry picked from commit 7710d513a552f1fa1b7485ec6b318bafaa6d4cd7)

diff --git a/gcc/config/i386/i386.cc b/gcc/config/i386/i386.cc
index 2e1a31d0540..94e29fa4321 100644
--- a/gcc/config/i386/i386.cc
+++ b/gcc/config/i386/i386.cc
@@ -12218,11 +12218,12 @@ legitimize_tls_address (rtx x, enum tls_model model, bool for_mov)
 	  if (TARGET_64BIT)
 	    {
 	      rtx rax = gen_rtx_REG (Pmode, AX_REG);
+	      rtx rdi = gen_rtx_REG (Pmode, DI_REG);
 	      rtx_insn *insns;
 
 	      start_sequence ();
 	      emit_call_insn
-		(gen_tls_global_dynamic_64 (Pmode, rax, x, caddr));
+		(gen_tls_global_dynamic_64 (Pmode, rax, x, caddr, rdi));
 	      insns = get_insns ();
 	      end_sequence ();
 
